#include "chdecl.h"
void CH_disassembler_disoperation(current, sched, cop)
#define ARGUMENTS 8
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto cb4;
    case 4: goto c5;
    case 5: goto c10;
    case 6: goto cb11;
    case 7: goto c12;
    case 8: goto c16;
    case 9: goto cb23;
    case 10: goto c24;
    case 11: goto c38;
    case 12: goto c42;
    case 13: goto c43;
    case 14: goto c46;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* new_table 4 , 2 */
  if ((ch_returncode = che_new_table(DEF(4),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
  current->ip = 3;
cb4:
/* call 3.0.3 3.1.0 5 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(3),
          arguments[1] = DEF(3)DOT(1)DOT(0),
          arguments[2] = DEF(5),
          arguments[2+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* merge 4 5 */
  if ((ch_returncode = mergefunc(DEF(4),DEF(5),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 6 , 32 */
  REF(6).value.ord_enum = 32;
  REF(6).tsdr = & dr_ord_enumeration;
/* insert 4 6 */
  if ((ch_returncode = insertfunc(DEF(4),DEF(6),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* copy 7 3.1.1 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(1)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = & dr_table;
/* initget 8 7 , 0,0 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(8),DEF(7),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c10:
/* get_or_goto 8 7 , 16 */
  if ((ch_returncode = get_selected_object(DEF(8),DEF(7),sched)) != Normal)
     goto c16;
  current->ip = 6;
cb11:
/* call 3.0.4 3.0 8 9 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(4),
          arguments[1] = DEF(3)DOT(0),
          arguments[2] = DEF(8),
          arguments[3] = DEF(9),
          arguments[3+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c12:
/* merge 4 9 */
  if ((ch_returncode = mergefunc(DEF(4),DEF(9),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 10 , 32 */
  REF(10).value.ord_enum = 32;
  REF(10).tsdr = & dr_ord_enumeration;
/* insert 4 10 */
  if ((ch_returncode = insertfunc(DEF(4),DEF(10),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 10 */
   goto c10;
c16:
/* endget 8 7 */
  end_selector(DEF(8),DEF(7),sched,GET);
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* case 11 3.1.2 */
  REF(11).value.enumeration = REF(3)DOT(1)DOT(2).value.variant
    ->info.variant_case;
  REF(11).tsdr = & dr_enumeration;
/* notequal . 11 =(0) , 23 */
  if ( REF(11).value.enumeration != 0 ) goto c23;
/* branch , 38 */
   goto c38;
c23:
  current->ip = 9;
cb23:
/* call 3.0.5 3.0 3.1.2 3.1.0 3.2 12 , 5 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(5),
          arguments[1] = DEF(3)DOT(0),
          arguments[2] = DEF(3)DOT(1)DOT(2),
          arguments[3] = DEF(3)DOT(1)DOT(0),
          arguments[4] = DEF(3)DOT(2),
          arguments[5] = DEF(12),
          arguments[5+1] = nil,& arguments[0]),QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
  return;
c24:
/* noop */
  
/* boolean 13 , FALSE */
  REF(13).value.boolean = FALSE;
  REF(13).tsdr = & dr_boolean;
/* initget 14 12 , 0,0 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(14),DEF(12),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
/* get_or_goto 14 12 , 29 */
  if ((ch_returncode = get_selected_object(DEF(14),DEF(12),sched)) != Normal)
     goto c29;
/* boolean 13 , TRUE */
  REF(13).value.boolean = TRUE;
  REF(13).tsdr = & dr_boolean;
c29:
/* endget 14 12 */
  end_selector(DEF(14),DEF(12),sched,GET);
/* branch_false 13 , 37 */
  if ( !REF(13).value.boolean ) goto c37;
/* ordenum_lit 15 , 44 */
  REF(15).value.ord_enum = 44;
  REF(15).tsdr = & dr_ord_enumeration;
/* insert 4 15 */
  if ((ch_returncode = insertfunc(DEF(4),DEF(15),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 16 , 32 */
  REF(16).value.ord_enum = 32;
  REF(16).tsdr = & dr_ord_enumeration;
/* insert 4 16 */
  if ((ch_returncode = insertfunc(DEF(4),DEF(16),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* merge 4 12 */
  if ((ch_returncode = mergefunc(DEF(4),DEF(12),FALSE,0)) != Normal)
     goto ch_raise_exception;
c37:
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
c38:
/* move 3.3 4 */
  (*(REF(3)DOT(3).tsdr)->finalize)(REF(3)DOT(3).value,F_DISCARD,sched);
  REF(3)DOT(3) = REF(4);
  REF(4).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 43 */
   goto c43;
c42:
/* return_exception 3 , 6 */
  if (ch_caller = do_return(REF(3).value)) {
    raise_user(QUAL(6),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(3),QUAL(6));
  REF(3).tsdr = & dr_bottom;
c43:
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c46:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
